package glzt.wifi.control;

import glzt.common.unit.ServiceMsg;
import glzt.ui.video.MonitorView;
import glzt.util.ConnectData;
import glzt.util.ConstantData;
import glzt.util.ProfileList;

import java.io.IOException;
import java.io.InputStream;
import java.net.DatagramSocket;
import java.net.Socket;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v4.app.FragmentActivity;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.Toast;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.TextView;
import android.widget.ToggleButton;
import java.util.Timer;
import java.util.TimerTask;

// ʵֻģʽ档ʵֻģʽ棨 ʵ֣
public class BasicControlActivity extends FragmentActivity implements OnClickListener, OnCheckedChangeListener, OnLongClickListener{
	private MonitorView mv;
	private ImageView imgbg;
	private Handler handler = new Handler() {
		@Override
		public void handleMessage(final Message msg) {
			super.handleMessage(msg);
			final boolean success = msg.getData().getBoolean("success");
			switch (msg.what) {
			case 0:
				
				break;
			case 1:
				break;
			case ServiceMsg.ON_MSG_REQUEST_VIDEOS_INFO :
				Log.i("BasicControlActivity","Basic hander receive ON_MSG_REQUEST_VIDEOS_INFO");
				asyncUpdateUI(new Runnable() {
					@Override
					public void run() {
						if(success){
							
							
							String videoUrl ="192.168.8.1/8080";
							mv.setSource(videoUrl);
							mv.setHandler(getHandler());
							mv.setVisibility(View.VISIBLE);
						}else{
							
						}
					}
				});
				break;
			case ServiceMsg.ON_MSG_CONNECT_VIDEO_INFO :
				Log.i("BasicControlActivity","Basic hander receive ON_MSG_CONNECT_VIDEO_INFO");
				//imgbg.setVisibility(View.VISIBLE); 
				//mv.setVisibility(View.INVISIBLE); 
				if(success){

				}else{
					
				}
				break;

			case ServiceMsg.ON_MSG_RESTART_VIDEO_INFO:
				Log.i("BasicControlActivity","Basic hander receive ON_MSG_RESTART_VIDEO_INFO");
				break;
			}
		
		}
	};
	public Handler getHandler() {
		return handler;
	}
	
	public void asyncUpdateUI(Runnable run) {
		Activity av = BasicControlActivity.this;
		if (av != null)
			av.runOnUiThread(run);
	}
	
 	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);//ȥ⣨Ӧõ) 
		//趨ҪдsetContentView֮ǰ쳣
		this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		//setContentView(new ControlSurfaceView(this));
		
		//  udp̡߳߳udp socketɹ򱣳socketapplication
		threadApplyUDPSocket = new Thread(new threadApplyUDPSocket());
		isApplyUDPSocket = true;
		threadApplyUDPSocket.start();
		
	}
	
	  @Override
		protected void onResume() {    	
	    	findView();        
			super.onResume();		
		}
	
	public class threadApplyUDPSocket implements Runnable{
		int connectCount = 0;
		Message message;
		@Override
		public void run() {
			while (isApplyUDPSocket) {
				try {
					BasicCtrlSurfaceView.udpSocket = new DatagramSocket(ConnectData.UDP_PORT);
					isApplyUDPSocket = false;
					app.setCurServerUDPSocket(BasicCtrlSurfaceView.udpSocket);
					BasicCtrlSurfaceView.isUDPConnected = true;
				}catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					BasicCtrlSurfaceView.isUDPConnected = false;
				}
			}
		}
	}
	
	@Override
	public void onClick(View v) {
        if (v == btnConfig) { 
        	Intent intent0 = new Intent(BasicControlActivity.this, ConfigAllActivity.class);
						
			Bundle bundle = new Bundle();  
            bundle.putString("fromActivity", "BasicControlActivity");  
             
            intent0.putExtras(bundle);
    		startActivity(intent0);    				
        } else if (v == btnBack) {
        	// Ϣأ
        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
        	if(mReceiveThread != null)
        	{
        		stop = true;
        		//mReceiveThread.interrupt();
        		//Log.i("Mike","RecieveThread destoryed...");
        	}
        	if(activityName.equals("WifiControlActivity")){
        		Intent intent0 = new Intent(BasicControlActivity.this, WifiControlActivity.class);
        		Bundle bundle = new Bundle();
                bundle.putString("fromActivity", "BasicControlActivity"); 
                intent0.putExtras(bundle);
             	startActivity(intent0);
        	}else if(activityName.equals("ConfigAllActivity")){
        		Intent intent0 = new Intent(BasicControlActivity.this, ConfigAllActivity.class);
        		Bundle bundle = new Bundle(); 
                bundle.putString("fromActivity", "BasicControlActivity"); 
                intent0.putExtras(bundle);
             	startActivity(intent0);
        	}else{
        		finish();
        	}
        } else if(v == btnTrimUp){
			//btnTrimUp.setVisibility(v.INVISIBLE);
			iTrimUpDown++;
			if(iTrimUpDown > ConstantData.MAXIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MAXIMUM_TRIM_VALUE;			
			tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
        	// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}else if(v == btnTrimDown){
			iTrimUpDown--;
			if(iTrimUpDown < ConstantData.MINIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MINIMUM_TRIM_VALUE;
			tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
			// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}else if(v == btnTrimLeft){			
			iTrimLeftRight--;
			if(iTrimLeftRight < ConstantData.MINIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MINIMUM_TRIM_VALUE;
			tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");
        	// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}else if(v == btnTrimRight){
			iTrimLeftRight++;
			if(iTrimLeftRight > ConstantData.MAXIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MAXIMUM_TRIM_VALUE;
			tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");
			// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}else if(v == btnDRUp){
			iDRUpDown++;
			if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
			tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
			// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}else if(v == btnDRDown){
			iDRUpDown--;
			if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
			tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
			// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}else if(v == btnDRLeft){
			iDRLeftRight--;
			if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
			tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");
			// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}else if(v == btnDRRight){
			iDRLeftRight++;
			if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
			tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");
			// ʵʱֵ
        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
        	BasicCtrlSurfaceView.commitConfig();
		}		
	}
	
	
	@Override
	public boolean onLongClick(View v) {
		if(v == btnTrimUp){
			setTimer(btnTrimUp);	    
		}else if(v == btnTrimDown){
			setTimer(btnTrimDown);
		}else if(v == btnTrimLeft){			
			setTimer(btnTrimLeft);
		}else if(v == btnTrimRight){
			setTimer(btnTrimRight);
		}else if(v == btnDRUp){
			setTimer(btnDRUp);
		}else if(v == btnDRDown){
			setTimer(btnDRDown);
		}else if(v == btnDRLeft){
			setTimer(btnDRLeft);
		}else if(v == btnDRRight){
			setTimer(btnDRRight);
		}		
		return false;
	}
	
	
    @Override
	protected void onDestroy() {
    	if(null != mReceiveThread)
    	{
    		stop = true;
    		//Log.i("BasicControlActivity","RecieveThread destoryed...");
    	}
    	
    	//isWifiMonitorOn = false;
    	
    	/*
    	if(null != app.getCurServerSocket()){
    		try{
    			app.getCurServerSocket().close();
    			Log.i("BasicControlActivity","Close socket...");
    		}catch(Exception e){
    			Log.e("BasicControlActivity","failed to close socket in BasicControlActivity.java");
    		}
    	}
    	*/
    	if(null != threadApplyUDPSocket)
    	{
    		isApplyUDPSocket = false;
    	}
    	if(null != BasicCtrlSurfaceView.udpSocket){
    		BasicCtrlSurfaceView.udpSocket.close();
    		app.setCurServerUDPSocket(null);
    	}
		super.onDestroy();		
	}
    
    @Override
    protected void onPause(){
    	if(null != mReceiveThread){
        	stop = true;
        } 
    	super.onPause();
    }
    
    
  
    
    private void findView(){
    	// surfaceViewsocketϢڻûݸwifiģ
    	app = ((ConnectWifiApplication) getApplicationContext());
		BasicCtrlSurfaceView.socketServer = app.getCurServerSocket();		        
		BasicCtrlSurfaceView.currentPL = app.readCurrentProfile();
		pl = new ProfileList();
		pl = app.readCurrentProfile();
		
		//android.util.DisplayMetrics  
        DisplayMetrics dm = new DisplayMetrics();  
        getWindowManager().getDefaultDisplay().getMetrics(dm);  
        
        BasicCtrlSurfaceView.screenWidth = dm.widthPixels;
        BasicCtrlSurfaceView.screenHeight = dm.heightPixels;
		dm = null;
		
		if(ConstantData.BASIC_RELATIVE_TOUCH_MODE == pl.iControlMode){
			ConstantData.isRelativeTouchOn = true;
		}else{
			ConstantData.isRelativeTouchOn = false;
		}
		
		if((ConstantData.BASIC_TOUCH_MODE == pl.iControlMode)||
		   (ConstantData.BASIC_RELATIVE_TOUCH_MODE == pl.iControlMode)){
			setContentView(R.layout.basic_control_mode_layout);
		}else if(ConstantData.BASIC_TOUCH_REV_MODE == pl.iControlMode){
			setContentView(R.layout.basic_control_mode_reverse_layout);
		}    	
		
		camra = (ToggleButton)findViewById(R.id.camra);
		camra.setTextOn("Camra ON");
		camra.setTextOff("Camra Off");
		camra.setChecked(true);
		
		
		
		mv = (MonitorView)findViewById(R.id.monitor_surface);
		mv.setDisplayMode(MonitorView.SIZE_BEST_FIT);
		
		//String videoUrl = "http://192.168.20.1:8020/?action=stream";
		String videoUrl = ConnectData.videoUrl_connect_videoIP_Port;
		mv.setSource(videoUrl);
		mv.setSessionStart(true);
		mv.setChangeSetting(false);
		mv.setHandler(getHandler());
		mv.setVisibility(View.VISIBLE); 
		
		mv.setBlnDisplayCamra(true);
		
	   
		imgbg = (ImageView)findViewById(R.id.back_img);
		imgbg.setVisibility(View.INVISIBLE); 
		
        pl = null;
        
        btnConfig = (Button) findViewById(R.id.Config);  
        btnConfig.setOnClickListener(this);  
            	        
        btnBack = (Button) findViewById(R.id.Back);  
        btnBack.setOnClickListener(this);
        
        btnTrimUp = (Button)findViewById(R.id.btnTrimUp);
        btnTrimUp.setOnClickListener(this);
        btnTrimUp.setOnLongClickListener(this);
        
        btnTrimDown = (Button)findViewById(R.id.btnTrimDown);
        btnTrimDown.setOnClickListener(this);
        btnTrimDown.setOnLongClickListener(this);
        
        btnTrimLeft = (Button)findViewById(R.id.btnTrimLeft);
        btnTrimLeft.setOnClickListener(this);
        btnTrimLeft.setOnLongClickListener(this);
        
        btnTrimRight = (Button)findViewById(R.id.btnTrimRight);
        btnTrimRight.setOnClickListener(this);
        btnTrimRight.setOnLongClickListener(this);
        
        btnDRUp = (Button)findViewById(R.id.btnDRUp);
        btnDRUp.setOnClickListener(this);
        btnDRUp.setOnLongClickListener(this);

        btnDRDown = (Button)findViewById(R.id.btnDRDown);
        btnDRDown.setOnClickListener(this);
        btnDRDown.setOnLongClickListener(this);

        btnDRLeft = (Button)findViewById(R.id.btnDRLeft);
        btnDRLeft.setOnClickListener(this);
        btnDRLeft.setOnLongClickListener(this);
        
        btnDRRight = (Button)findViewById(R.id.btnDRRight);
        btnDRRight.setOnClickListener(this);
        btnDRRight.setOnLongClickListener(this);
        
        tvTrimUpDown = (TextView)findViewById(R.id.tvTrimUpDown);
        tvTrimLeftRight = (TextView)findViewById(R.id.tvTrimLeftRight);
        
        tvDRUpDown = (TextView)findViewById(R.id.tvDRUpDown);
        tvDRLeftRight = (TextView)findViewById(R.id.tvDRLeftRight);
        
        tglBtnRealTimeCfg=(ToggleButton)findViewById(R.id.tglBtnRealTimeCfg); 
        tglBtnRealTimeCfg.setTextOn("Settings");
        tglBtnRealTimeCfg.setTextOff("Settings");
        tglBtnRealTimeCfg.setOnCheckedChangeListener(this);
        camra.setOnCheckedChangeListener(this);
        visibleFlag = tglBtnRealTimeCfg.isChecked();
        BasicCtrlSurfaceView.isInRealTimeCfg = visibleFlag;
        
        setRealTimeCfgVisible(visibleFlag);        
        
        //õactivityʱ
        intent = this.getIntent();  
        activityName = intent.getStringExtra("fromActivity");
        
        iTrimUpDown = BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC];
        iTrimLeftRight = BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR];
        tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
        tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");
        
        iDRUpDown = BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC];
        iDRLeftRight = BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR];
        tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
        tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");
        
        BasicCtrlSurfaceView.commitConfig();
        
        // ȡ/ʾwifiϢ:
        tvWifiStatus = (TextView)findViewById(R.id.tvWifiStatus);
        tvWifiStatus.setVisibility(View.INVISIBLE);
        
        wifiManager = (WifiManager)this.getSystemService(Context.WIFI_SERVICE);        
        
        // Ϣ߳(߳ʱʾwifiϢĹ)
        if(null != BasicCtrlSurfaceView.socketServer){
        	mReceiveThread = new ReceiveThread(BasicCtrlSurfaceView.socketServer);
        	stop = false;
        	//߳
        	mReceiveThread.start();
        }
        
        /*
		threadWifiMon = new Thread(new threadWifiMonitor());
		isWifiMonitorOn = true;
		threadWifiMon.start();
		*/
    }
    
    // ΪtcpĽ̡߳ɲ
	private class ReceiveThread extends Thread
	{
	    private InputStream inStream = null;
	    Message messageInRecv;
	    private byte[] buf = new byte[512];;  
	    //private String str = null;
	    
	    ReceiveThread(Socket s)
	    {
	        try {
	            //
	            this.inStream = s.getInputStream();	            
	        } catch (IOException e) {
	            e.printStackTrace();
	            if(IS_CHECK_RECV_SWITCH){
		            BasicCtrlSurfaceView.isSocketOK = false;
		            //Log.e("BasicControlActivity 1","Socket NOK 1 !!!!");
	            }else{
	            	BasicCtrlSurfaceView.isSocketOK = true;
	            }
	        }
	    }      
	    
	    @Override
	    public void run()
	    {
	    	// ȡ/ʾwifiٶ/ǿ õı
	    	// String textStr = new String();
	        while(!stop)
	        {
	            if((null != app.getCurServerSocket())&&(null!=this.inStream))
	            {
	            	try {
	            		//ȡݣ
	            		this.inStream.read(this.buf);
	            		BasicCtrlSurfaceView.isSocketOK = true;
	            		BasicCtrlSurfaceView.recvFailedCount = 0;
	            		//Log.e("recv msg","Socket OK");
	            	} catch (IOException e) {
	            		e.printStackTrace();
	            		if(IS_CHECK_RECV_SWITCH){	            			
	            			if(BasicCtrlSurfaceView.recvFailedCount<10){	            				
	            				BasicCtrlSurfaceView.recvFailedCount++;	            				
	            			}else{
	            				BasicCtrlSurfaceView.recvFailedCount = 0;
	            				BasicCtrlSurfaceView.isSocketOK = false; // tcpİжϣӰUDP
		            			//Log.e("recv msg 1","Socket NOK 1!!!!");
		            			//messageInRecv = new Message();
		            			//messageInRecv.getData().putString("location", "555");
		            			//messageInRecv.what = TMP_RECV_FAILED_TOAST;
	            				//handlerAll.sendMessage(messageInRecv);
	            				//messageInRecv = null;
	            			}
	            		}else{
	            			BasicCtrlSurfaceView.isSocketOK = true;
	            		}
	            	} 
	            }else{
	            	stop = true;
	            	if(IS_CHECK_RECV_SWITCH){
	            		if(BasicCtrlSurfaceView.recvFailedCount<10){	            				
            				BasicCtrlSurfaceView.recvFailedCount++;            				
            			}else{
            				BasicCtrlSurfaceView.recvFailedCount = 0;
            				BasicCtrlSurfaceView.isSocketOK = false;
			            	//Log.e("recv msg 2","Socket NOK 2 !!!!");
			            	//messageInRecv = new Message();
			            	//messageInRecv.getData().putString("location", "2");
			            	//messageInRecv.what = TMP_RECV_TOAST;
		    		    	//handlerAll.sendMessage(messageInRecv);
		    		    	//messageInRecv = null;
            			}		            	
	            	}else{
	            		BasicCtrlSurfaceView.isSocketOK = true;
	            	}
	            	//if(null==this.inStream)
	            		//Log.e("recv msg","inStream is null!!!!");
	            	break;
	            }
	            
	            /*
	            // ȡ/ʾwifiٶ/ǿ
    	        int level=INVALID_VALUE;
    	        WifiInfo wifiInfo = wifiManager.getConnectionInfo();
    	        if ((wifiInfo != null)&&(wifiManager.isWifiEnabled())) {
    	            int linkSpeed = wifiInfo.getLinkSpeed(); //measured using WifiInfo.LINK_SPEED_UNITS
    	            textStr = ("W:"+String.valueOf(linkSpeed)+"M");
    	            level = wifiInfo.getRssi();
    	            if(INVALID_VALUE!=level){
    	            	textStr+=","+String.valueOf(level)+"dBm";
    	            }else{
    	            	textStr+=",--dBm";
    	            }
    	        }else{
    	        	textStr = ("W:--M,--dBm");
    	        }
    	        
    	        messageInRecv = new Message();
    	        messageInRecv.getData().putString("WifiStatus", textStr);
    	        messageInRecv.what = SHOW_WIFI_STATUS;
		    	handlerAll.sendMessage(messageInRecv);
		    	messageInRecv = null;
		    	textStr = null;
    	        // ȡ/ʾwifiٶ/ǿ  
    	        */
		    	
		    	// ÿ100msһ߳
		    	try {
					Thread.sleep(100);
				} catch (Exception ex) {
				}
	        }
	        /*
	        if((stop)&&(null != this.inStream)){
				try {
					this.inStream.close();
					Log.i("inStream closed","BasicControlActivity");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        }
	        */
	    }  
	}

	@Override
	public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
		//isCheckedǰť״̬  
		int id  = buttonView.getId();
		switch(id){
		case R.id.tglBtnRealTimeCfg:
			if(isChecked){  
	        	visibleFlag = true;
	        	BasicCtrlSurfaceView.isInRealTimeCfg = visibleFlag;
	        	setRealTimeCfgVisible(visibleFlag);
	        	
	        }else{
	        	// ťoff״̬ػٿؽ(ȥť
	        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
	        	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
	        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
	        	BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
	        	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
	        	BasicCtrlSurfaceView.commitConfig();
				visibleFlag = false;
				setRealTimeCfgVisible(visibleFlag);
	        }        
			break;
		case R.id.camra:
			if(isChecked){
				Log.i("checked","true");
				mv.setBlnDisplayCamra(true);
				
			}else{
				Log.i("checked","false");
				mv.setBlnDisplayCamra(false);
			}
			break;
		}
        
	}
	
	private void setRealTimeCfgVisible(boolean vFlag){
		if(!vFlag){
			btnTrimUp.setVisibility(View.INVISIBLE);
			btnTrimDown.setVisibility(View.INVISIBLE);
			btnTrimLeft.setVisibility(View.INVISIBLE);
			btnTrimRight.setVisibility(View.INVISIBLE);
			btnDRUp.setVisibility(View.INVISIBLE);
			btnDRDown.setVisibility(View.INVISIBLE);
			btnDRLeft.setVisibility(View.INVISIBLE);
			btnDRRight.setVisibility(View.INVISIBLE);
			btnConfig.setVisibility(View.INVISIBLE);
			btnBack.setVisibility(View.INVISIBLE);
			tvTrimUpDown.setVisibility(View.INVISIBLE);
			tvDRUpDown.setVisibility(View.INVISIBLE);
			tvTrimLeftRight.setVisibility(View.INVISIBLE);
			tvDRLeftRight.setVisibility(View.INVISIBLE);
			
		}else{
			btnTrimUp.setVisibility(View.VISIBLE);
			btnTrimDown.setVisibility(View.VISIBLE);
			btnTrimLeft.setVisibility(View.VISIBLE);
			btnTrimRight.setVisibility(View.VISIBLE);
			btnDRUp.setVisibility(View.VISIBLE);
			btnDRDown.setVisibility(View.VISIBLE);
			btnDRLeft.setVisibility(View.VISIBLE);
			btnDRRight.setVisibility(View.VISIBLE);
			btnConfig.setVisibility(View.VISIBLE);
			btnBack.setVisibility(View.VISIBLE);
			tvTrimUpDown.setVisibility(View.VISIBLE);
			tvDRUpDown.setVisibility(View.VISIBLE);
			tvTrimLeftRight.setVisibility(View.VISIBLE);
			tvDRLeftRight.setVisibility(View.VISIBLE);
		}			
	}
	
	/**
	 * ͼڴй¶ܡĸ澯дhandlerڲ࣬Ŀǰ쳣 2012 07 25
	 */
	/*
	static class HandlerAll extends Handler {  
        WeakReference<BasicControlActivity> mActivity;  

        HandlerAll(BasicControlActivity activity) {  
                mActivity = new WeakReference<BasicControlActivity>(activity);  
        }  

        @Override  
        public void handleMessage(Message msg) {  
        	BasicControlActivity theActivity = mActivity.get();  

			String textStr;
			switch(msg.what) {
				case SHOW_WIFI_STATUS:
					tvWifiStatus.setVisibility(View.VISIBLE);
					textStr = msg.getData().getString("WifiStatus");
					tvWifiStatus.setText(textStr);
	    	        tvWifiStatus.invalidate();
	    	        break;
				case TRM_UP:
					iTrimUpDown++;
                	if(iTrimUpDown > ConstantData.MAXIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MAXIMUM_TRIM_VALUE;
                	theActivity.tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
                	break;
				case TRM_DOWN:
					iTrimUpDown--;
					if(iTrimUpDown < ConstantData.MINIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MINIMUM_TRIM_VALUE;
					theActivity.tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");                  	
					break;
				case TRM_LEFT:
					iTrimLeftRight--;
					if(iTrimLeftRight < ConstantData.MINIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MINIMUM_TRIM_VALUE;
					theActivity.tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");               	
					break;
				case TRM_RIGHT:
					iTrimLeftRight++;
					if(iTrimLeftRight > ConstantData.MAXIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MAXIMUM_TRIM_VALUE;
					theActivity.tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");                	
					break;
				case DR_UP:
					iDRUpDown++;
					if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
					theActivity.tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
					break;
				case DR_DOWN:
					iDRUpDown--;
					if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
					theActivity.tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
					break;
				case DR_LEFT:
					iDRLeftRight--;
					if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
					theActivity.tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");               	
					break;
				case DR_RIGHT:
					iDRLeftRight++;
					if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
					theActivity.tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");               	
					break;
				case TMP_RECV_TOAST:
					// release 汾Ҫɾʾ
					textStr = msg.getData().getString("location");
					Toast.makeText(theActivity,
							"Recv failed Location: "+ textStr,
							Toast.LENGTH_SHORT).show();
					break;
				case TMP_RECV_FAILED_TOAST:
					// release 汾Ҫɾʾ
					textStr = msg.getData().getString("location");
					Toast.makeText(theActivity,
							"Recv failed Location: "+ textStr,
							Toast.LENGTH_SHORT).show();
					break;
			}
			super.handleMessage(msg);
		  
        }  
	};  
	*/
	
	Handler handlerAll = new Handler() {
		 
		public void handleMessage(Message msg) {
			String textStr;
			switch(msg.what) {
				case SHOW_WIFI_STATUS:
					tvWifiStatus.setVisibility(View.VISIBLE);
					textStr = msg.getData().getString("WifiStatus");
					tvWifiStatus.setText(textStr);
	    	        tvWifiStatus.invalidate();
	    	        break;
				case TRM_UP:
					iTrimUpDown++;
                	if(iTrimUpDown > ConstantData.MAXIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MAXIMUM_TRIM_VALUE;
                	tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
                	break;
				case TRM_DOWN:
					iTrimUpDown--;
					if(iTrimUpDown < ConstantData.MINIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MINIMUM_TRIM_VALUE;
					tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");                  	
					break;
				case TRM_LEFT:
					iTrimLeftRight--;
					if(iTrimLeftRight < ConstantData.MINIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MINIMUM_TRIM_VALUE;
					tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");               	
					break;
				case TRM_RIGHT:
					iTrimLeftRight++;
					if(iTrimLeftRight > ConstantData.MAXIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MAXIMUM_TRIM_VALUE;
					tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");                	
					break;
				case DR_UP:
					iDRUpDown++;
					if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
					tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
					break;
				case DR_DOWN:
					iDRUpDown--;
					if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
					tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
					break;
				case DR_LEFT:
					iDRLeftRight--;
					if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
					tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");               	
					break;
				case DR_RIGHT:
					iDRLeftRight++;
					if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
					tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");               	
					break;
				case TMP_RECV_TOAST:
					// release 汾Ҫɾʾ
					textStr = msg.getData().getString("location");
					Toast.makeText(BasicControlActivity.this,
							"Recv failed Location: "+ textStr,
							Toast.LENGTH_SHORT).show();
					break;
				case TMP_RECV_FAILED_TOAST:
					// release 汾Ҫɾʾ
					textStr = msg.getData().getString("location");
					Toast.makeText(BasicControlActivity.this,
							"Recv failed Location: "+ textStr,
							Toast.LENGTH_SHORT).show();
					break;
			}
			super.handleMessage(msg);
		}
	};
	
	
	private void setTimer(final Button btn){
		final Timer t = new Timer();
        TimerTask tt = new TimerTask(){
            @Override
            public void run(){
            	Message message;
                if(btn.isPressed()){
                	message= new Message();
                	if(btnTrimUp == btn){
                	   message.what = TRM_UP;
                	}else if(btnTrimDown == btn){
                 	   message.what = TRM_DOWN;
                 	}else if(btnTrimLeft == btn){
                  	   message.what = TRM_LEFT;
                  	}else if(btnTrimRight == btn){
                  	   message.what = TRM_RIGHT;
                  	}else if(btnDRUp == btn){
                  	   message.what = DR_UP;
                  	}else if(btnDRDown == btn){
                  	   message.what = DR_DOWN;
                  	}else if(btnDRLeft == btn){
                  	   message.what = DR_LEFT;
                  	}else if(btnDRRight == btn){
                  	   message.what = DR_RIGHT;
                  	}
    		    	handlerAll.sendMessage(message);
    		    	message = null;
                }else{
                	// ť, ʱȥֵ(ջ͸º)
                	if((btnTrimUp == btn)||(btnTrimDown == btn)){
                		BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
                    	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
                    	BasicCtrlSurfaceView.commitConfig();
                  	}else if((btnTrimLeft == btn)||(btnTrimRight == btn)){
                    	BasicCtrlSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
                    	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
                    	BasicCtrlSurfaceView.commitConfig();
                   	}else if((btnDRUp == btn)||(btnDRDown == btn)){
                   		BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
                    	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
                    	BasicCtrlSurfaceView.commitConfig();
                   	}else if((btnDRLeft == btn)||(btnDRRight == btn)){
                   		BasicCtrlSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
                    	app.updateConfigToApp(BasicCtrlSurfaceView.currentPL);
                    	BasicCtrlSurfaceView.commitConfig();
                   	}
                	t.cancel();
            	}
            }
        };        
        t.schedule(tt, 50, 50);
	}
	

	/**
	 * wifi״̬Զʹ֮ǰȡصrecvSSIDkey
	 * @author Mike
	 *
	 */
	/*
	public class threadWifiMonitor implements Runnable{
		@Override
		public void run() {
			mWifiAdmin = new WifiAdmin(BasicControlActivity.this);
			while (isWifiMonitorOn) {
				try {
					
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
	*/
	
	/**
	 * ͼڴй¶ܡĸ澯дhandlerڲ࣬Ŀǰ쳣 2012 07 25
	 * Ϊڲʵ
	 */
	// HandlerAll handlerAll = new HandlerAll(this);
	
	protected static final int SHOW_WIFI_STATUS = 1001;
	protected static final int TRM_UP = 1002;
	protected static final int TRM_DOWN = 1003;
	protected static final int TRM_LEFT = 1004;
	protected static final int TRM_RIGHT = 1005;
	protected static final int DR_UP = 1006;
	protected static final int DR_DOWN = 1007;
	protected static final int DR_LEFT = 1008;
	protected static final int DR_RIGHT = 1009;
	protected static final int TMP_RECV_TOAST = 1200;
	protected static final int TMP_RECV_FAILED_TOAST = 1201;
	// ³surfaceViewϢͶ
	protected static final int MSG_RT_TRM_UP    = 4010;
	protected static final int MSG_RT_TRM_DOWN  =4011;
	protected static final int MSG_RT_TRM_LEFT  =4012;
	protected static final int MSG_RT_TRM_RIGHT = 4013;
	protected static final int MSG_RT_DR_UP = 4020;
	protected static final int MSG_RT_DR_DOWN = 4021;
	protected static final int MSG_RT_DR_LEFT = 4022;
	protected static final int MSG_RT_DR_RIGHT = 4023;
		
	private Button btnConfig, btnBack;  
	private ToggleButton tglBtnRealTimeCfg,camra;
	private boolean visibleFlag = false;// ʼĬΪȥť
    
    private Button btnTrimUp,btnTrimDown,btnTrimLeft,btnTrimRight;
	private Button btnDRUp,btnDRDown,btnDRLeft,btnDRRight;
	private static int iTrimUpDown = ConstantData.DEFAULT_TRIM_VALUE,iTrimLeftRight = ConstantData.DEFAULT_TRIM_VALUE;
	private static int iDRUpDown = ConstantData.DEFAULT_DR_VALUE,iDRLeftRight = ConstantData.DEFAULT_DR_VALUE;
    private static TextView tvWifiStatus;
	
	private TextView tvTrimUpDown,tvTrimLeftRight,tvDRUpDown,tvDRLeftRight;
	
	// UDP߳ر
	protected static boolean isApplyUDPSocket = false;
	private Thread threadApplyUDPSocket;
	
    // ߳ʹñ
	protected static final boolean IS_CHECK_RECV_SWITCH = true;
 	private boolean stop = true;
 	private ReceiveThread mReceiveThread = null;
 	
 	private ConnectWifiApplication app;
 	private Intent intent;
 	private String activityName;
 	 	
 	private ProfileList pl;
 	
 	// wifiϢر
 	WifiManager wifiManager;
 	//wifi״̬̱߳
 	/*
 	private Thread threadWifiMon;
 	private boolean isWifiMonitorOn = false;
 	private WifiAdmin mWifiAdmin;
	*/
}
