package glzt.wifi.control;

import glzt.util.ConstantData;
import glzt.util.ProfileList;

import java.util.Timer;
import java.util.TimerTask;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnLongClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;
import android.widget.SeekBar.OnSeekBarChangeListener;

public class ConfigChnActivity extends Activity implements OnClickListener{

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		
		setContentView(R.layout.config_chn);   
		//õactivityʱ
        Intent intent = this.getIntent();  
        //õ   profile
        fromActivity = intent.getStringExtra("fromActivity"); 
        
        // ϵͳжȡϢ
        app = (ConnectWifiApplication)this.getApplication();        
        currentCfg = app.readCurrentProfile();
        
        //android.util.DisplayMetrics  
        DisplayMetrics dm = new DisplayMetrics();  
        getWindowManager().getDefaultDisplay().getMetrics(dm);  
                
        iChnNum = currentCfg.iChannelNum;
        for(int i=0;i<iChnNum;i++){
			iTRM[i] = currentCfg.iTrim[i];
			iDR[i] =currentCfg.iDR[i];
			iEPAPositive[i] = currentCfg.iEPAPositive[i];
			iEPANegative[i] = currentCfg.iEPANegative[i];
			bChnRev[i] = currentCfg.bChannelReverse[i];
			iEXP[i] = currentCfg.iEXPControl[i];
		}
        
        // ȡĵǰʾڰťϣť
        btnBack = (Button)findViewById(R.id.Back);
        btnBack.setOnClickListener(this);
        
        btnSaveNBack = (Button)findViewById(R.id.btnSaveNBack);
        btnSaveNBack.setOnClickListener(this);
        
        btnDiscard = (Button)findViewById(R.id.btnDiscard);
        btnDiscard.setOnClickListener(this);
        
        
        
        btnChnRev = (Button)findViewById(R.id.btnChnRev);
        btnChnRev.setOnClickListener(this);        
        
        btnTRM = (Button)findViewById(R.id.btnTRM);
        btnTRM.setOnClickListener(this);         
        
        btnEPA = (Button)findViewById(R.id.btnEPA);
        btnEPA.setOnClickListener(this);
        
        btnDR = (Button)findViewById(R.id.btnDR);
        btnDR.setOnClickListener(this);
        
        btnEXP = (Button)findViewById(R.id.btnEXP);
        btnEXP.setOnClickListener(this);
        
        btnChnNumLeft = (Button)findViewById(R.id.btnChnNumLeft);
        btnChnNumLeft.setOnClickListener(this);
        
        btnChnNumRight = (Button)findViewById(R.id.btnChnNumRight);
        btnChnNumRight.setOnClickListener(this);
        
        tvChnNum = (TextView)findViewById(R.id.tvChnNum);
        tvChnNum.setText(String.valueOf(iChnNum));
        
        updateOtherCfgView();
	}
	
	@Override
	public void onClick(View v) {
			if((v == btnBack)||(v == btnSaveNBack)){
			
			currentCfg.iChannelNum = iChnNum;
			for(int i=0;i<iChnNum;i++){
				currentCfg.iTrim[i] = iTRM[i];
				currentCfg.iDR[i] = iDR[i];
				currentCfg.iEPAPositive[i] = iEPAPositive[i];
				currentCfg.iEPANegative[i] = iEPANegative[i];
				currentCfg.bChannelReverse[i] = bChnRev[i];
				currentCfg.iEXPControl[i] = iEXP[i];
			}
			
			
			app.updateConfigToApp(currentCfg);
						
			if(fromActivity.equals("BasicControlActivity")){
				Intent intent0 = new Intent(ConfigChnActivity.this, BasicControlActivity.class);
				startActivity(intent0);
	        }else if (fromActivity.equals("ConfigAllActivity")){
	        	Intent intent0 = new Intent(ConfigChnActivity.this, ConfigAllActivity.class);
	        	startActivity(intent0);
	        }else if(fromActivity.equals("BasicGLSurfaceViewActivity")){
				Intent intent0 = new Intent(ConfigChnActivity.this, BasicGLSurfaceViewActivity.class);
				startActivity(intent0);
	        }
		}else if(v == btnDiscard){
			// ޸ģֱӷ
			if(fromActivity.equals("BasicControlActivity")){
				Intent intent0 = new Intent(ConfigChnActivity.this, BasicControlActivity.class);
				startActivity(intent0);
	        }else if (fromActivity.equals("ConfigAllActivity")){
	        	Intent intent0 = new Intent(ConfigChnActivity.this, ConfigAllActivity.class);
	        	startActivity(intent0);
	        }else if(fromActivity.equals("BasicGLSurfaceViewActivity")){
				Intent intent0 = new Intent(ConfigChnActivity.this, BasicGLSurfaceViewActivity.class);
				startActivity(intent0);
	        }
		}else if(v == btnChnRev){
			// Ի򣬴ťѡ ͨķת
			inputChnRev();
		}else if(v == btnTRM){
			// ԻTrim
			inputTRM();
		}else if(v == btnEPA){
			// Ի
			inputEPA();
		}else if(v == btnDR){
			// Ի
			inputDR();
		}else if(v == btnEXP){
			// Ի
			inputEXP();
		}else if(v == btnChnNumLeft){
			if(iChnNum > 0) iChnNum--;
			tvChnNum.setText(String.valueOf(iChnNum));	
			updateOtherCfgView();
		}else if(v == btnChnNumRight){
			if(iChnNum < ConstantData.MAX_CHANNEL_NUM) iChnNum++;
			tvChnNum.setText(String.valueOf(iChnNum));
			updateOtherCfgView();
		}
		
	}
	

	private void inputChnRev(){
		/**ȡinput_new_profile.xmlļеͼ*/  
        LayoutInflater inflater = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);  
        final View revView = inflater.inflate(R.layout.input_chn_rev_dlg, null);  
        ToggleButton tbChnRev[] = new ToggleButton[ConstantData.MAX_CHANNEL_NUM];
        tbChnRev[0] = (ToggleButton) revView.findViewById(R.id.tbChnRev1);
        tbChnRev[1] = (ToggleButton) revView.findViewById(R.id.tbChnRev2);
        tbChnRev[2] = (ToggleButton) revView.findViewById(R.id.tbChnRev3);
        tbChnRev[3] = (ToggleButton) revView.findViewById(R.id.tbChnRev4);
        
        TextView tvRev[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        tvRev[0] = (TextView)revView.findViewById(R.id.tvRev1);
        tvRev[1] = (TextView)revView.findViewById(R.id.tvRev2);
        tvRev[2] = (TextView)revView.findViewById(R.id.tvRev3);
        tvRev[3] = (TextView)revView.findViewById(R.id.tvRev4);
        
        for(int i=0; i < ConstantData.MAX_CHANNEL_NUM;i++){
        	tbChnRev[i].setChecked(bChnRev[i]);
        	if(i>=iChnNum){
        		tbChnRev[i].setVisibility(View.INVISIBLE);
        		tvRev[i].setVisibility(View.INVISIBLE);
        	}
        }
        
        tbChnRev[0].setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {				
				if(isChecked){
					bChnRev[0] = true;
				}else{
					bChnRev[0] = false;
				}				
			}
        });
        
        tbChnRev[1].setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {				
				if(isChecked){
					bChnRev[1] = true;
				}else{
					bChnRev[1] = false;
				}				
			}
        });
        
        tbChnRev[2].setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {				
				if(isChecked){
					bChnRev[2] = true;
				}else{
					bChnRev[2] = false;
				}				
			}
        });
        
        tbChnRev[3].setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {				
				if(isChecked){
					bChnRev[3] = true;
				}else{
					bChnRev[3] = false;
				}				
			}
        });
        
        new AlertDialog.Builder(ConfigChnActivity.this).setTitle("Input Channel REV").setView(revView).setPositiveButton(
        		"OK",new DialogInterface.OnClickListener() {              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) { 
            	updateOtherCfgView();
            }  
            /**ӶԻ˳ť,ðťӦ¼*/  
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) {
            	for(int i=0;i<iChnNum;i++){
               	 bChnRev[i] = currentCfg.bChannelReverse[i]; //ԭֵŻأ޸
                }  
            }  
        }).show(); 
	}
	
	private void inputTRM(){
		
		/**ȡinput_new_profile.xmlļеͼ*/  
        LayoutInflater inflater = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);  
        final View TRMView = inflater.inflate(R.layout.input_trm_dlg, null);  
        final Button btnTRMLeft[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnTRMLeft[0] = (Button) TRMView.findViewById(R.id.btnTRMLeft1);
        btnTRMLeft[1] = (Button) TRMView.findViewById(R.id.btnTRMLeft2);
        btnTRMLeft[2] = (Button) TRMView.findViewById(R.id.btnTRMLeft3);
        btnTRMLeft[3] = (Button) TRMView.findViewById(R.id.btnTRMLeft4);
        final Button btnTRMRight[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnTRMRight[0] = (Button) TRMView.findViewById(R.id.btnTRMRight1);
        btnTRMRight[1] = (Button) TRMView.findViewById(R.id.btnTRMRight2);
        btnTRMRight[2] = (Button) TRMView.findViewById(R.id.btnTRMRight3);
        btnTRMRight[3] = (Button) TRMView.findViewById(R.id.btnTRMRight4);
        
        final SeekBar sbTRM[] = new SeekBar[ConstantData.MAX_CHANNEL_NUM];
        sbTRM[0]=(SeekBar)TRMView.findViewById(R.id.sbTRMChn1);
        sbTRM[1]=(SeekBar)TRMView.findViewById(R.id.sbTRMChn2);
        sbTRM[2]=(SeekBar)TRMView.findViewById(R.id.sbTRMChn3);
        sbTRM[3]=(SeekBar)TRMView.findViewById(R.id.sbTRMChn4);
        
        TextView tvChn[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        final TextView tvChnValue[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        
        tvChn[0] = (TextView)TRMView.findViewById(R.id.tvTRMChn1);
        tvChn[1] = (TextView)TRMView.findViewById(R.id.tvTRMChn2);
        tvChn[2] = (TextView)TRMView.findViewById(R.id.tvTRMChn3);
        tvChn[3] = (TextView)TRMView.findViewById(R.id.tvTRMChn4);
        tvChnValue[0] = (TextView)TRMView.findViewById(R.id.tvTRMValue1);
        tvChnValue[1] = (TextView)TRMView.findViewById(R.id.tvTRMValue2);
        tvChnValue[2] = (TextView)TRMView.findViewById(R.id.tvTRMValue3);
        tvChnValue[3] = (TextView)TRMView.findViewById(R.id.tvTRMValue4);
        
        for(int i=0; i < ConstantData.MAX_CHANNEL_NUM;i++){
        	sbTRM[i].setMax(TRM_SEEKBAR_SCALE);
        	sbTRM[i].setProgress(iTRM[i]+TRM_SEEKBAR_OFFSET);
        	tvChnValue[i].setText(String.valueOf(iTRM[i])+"%");
        	if(i>=iChnNum){
        		tvChn[i].setVisibility(View.INVISIBLE);
        		tvChnValue[i].setVisibility(View.INVISIBLE);
        		btnTRMLeft[i].setVisibility(View.INVISIBLE);
        		btnTRMRight[i].setVisibility(View.INVISIBLE);
        		sbTRM[i].setVisibility(View.INVISIBLE);        		
        	}
        	
        }
        
        // handler,ť¼(textViewݳ/):
        final Handler handlerTRM = new Handler() {
    		public void handleMessage(Message msg) {
    			switch(msg.what) {
    				case TRM_LEFT0:
    					if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[0]) iTRM[0]--;
    					sbTRM[0].setProgress(iTRM[0]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[0].setText(String.valueOf(iTRM[0])+"%");
    					break;
    				case TRM_LEFT1:
    					if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[1]) iTRM[1]--;
    					sbTRM[1].setProgress(iTRM[1]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[1].setText(String.valueOf(iTRM[1])+"%");
    					break;
    				case TRM_LEFT2:
    					if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[2]) iTRM[2]--;
    					sbTRM[2].setProgress(iTRM[2]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[2].setText(String.valueOf(iTRM[2])+"%");
    					break;
    				case TRM_LEFT3:
    					if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[3]) iTRM[3]--;
    					sbTRM[3].setProgress(iTRM[3]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[3].setText(String.valueOf(iTRM[3])+"%");
    					break;
    				case TRM_RIGHT0:
    					if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[0]) iTRM[0]++;
    					sbTRM[0].setProgress(iTRM[0]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[0].setText(String.valueOf(iTRM[0])+"%");
    					break;
    				case TRM_RIGHT1:
    					if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[1]) iTRM[1]++;
    					sbTRM[1].setProgress(iTRM[1]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[1].setText(String.valueOf(iTRM[1])+"%");
    					break;
    				case TRM_RIGHT2:
    					if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[2]) iTRM[2]++;
    					sbTRM[2].setProgress(iTRM[2]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[2].setText(String.valueOf(iTRM[2])+"%");
    					break;
    				case TRM_RIGHT3:
    					if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[3]) iTRM[3]++;
    					sbTRM[3].setProgress(iTRM[3]+TRM_SEEKBAR_OFFSET);
    		        	tvChnValue[3].setText(String.valueOf(iTRM[3])+"%");
    					break;
    			}
    			super.handleMessage(msg);
    		}
    	};
        // handler
        
    	// TRMĳ¼
    	// Left:
        btnTRMLeft[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMLeft[0].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_LEFT0;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnTRMLeft[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMLeft[1].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_LEFT1;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnTRMLeft[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMLeft[2].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_LEFT2;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnTRMLeft[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMLeft[3].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_LEFT3;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // Right:
        btnTRMRight[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMRight[0].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_RIGHT0;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnTRMRight[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMRight[1].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_RIGHT1;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnTRMRight[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMRight[2].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_RIGHT2;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnTRMRight[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnTRMRight[3].isPressed()){
		                	Message message = new Message();
		                	message.what = TRM_RIGHT3;		                	
		    		    	handlerTRM.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // TRMĳ¼ 
        
        // TRMͨ
        btnTRMLeft[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[0]) iTRM[0]--;
				sbTRM[0].setProgress(iTRM[0]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[0].setText(String.valueOf(iTRM[0])+"%");
			}        	
        });
        
        btnTRMLeft[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[1]) iTRM[1]--;
				sbTRM[1].setProgress(iTRM[1]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[1].setText(String.valueOf(iTRM[1])+"%");
			}        	
        });
        
        btnTRMLeft[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[2]) iTRM[2]--;
				sbTRM[2].setProgress(iTRM[2]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[2].setText(String.valueOf(iTRM[2])+"%");
			}        	
        });
        
        btnTRMLeft[3].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_TRIM_VALUE < iTRM[3]) iTRM[3]--;
				sbTRM[3].setProgress(iTRM[3]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[3].setText(String.valueOf(iTRM[3])+"%");
			}        	
        });
        
        btnTRMRight[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[0]) iTRM[0]++;
				sbTRM[0].setProgress(iTRM[0]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[0].setText(String.valueOf(iTRM[0])+"%");
			}        	
        });
        
        btnTRMRight[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[1]) iTRM[1]++;
				sbTRM[1].setProgress(iTRM[1]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[1].setText(String.valueOf(iTRM[1])+"%");
			}        	
        });
        
        btnTRMRight[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[2]) iTRM[2]++;
				sbTRM[2].setProgress(iTRM[2]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[2].setText(String.valueOf(iTRM[2])+"%");
			}        	
        });
        
        btnTRMRight[3].setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_TRIM_VALUE > iTRM[3]) iTRM[3]++;
				sbTRM[3].setProgress(iTRM[3]+TRM_SEEKBAR_OFFSET);
	        	tvChnValue[3].setText(String.valueOf(iTRM[3])+"%");
			}        	
        });       
        // TRMͨ 
        
        
        sbTRM[0].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iTRM[0] = progress-TRM_SEEKBAR_OFFSET;
        		tvChnValue[0].setText(String.valueOf(iTRM[0])+"%");
        	}
        });
        
        sbTRM[1].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iTRM[1] = progress-TRM_SEEKBAR_OFFSET;
        		tvChnValue[1].setText(String.valueOf(iTRM[1])+"%");
        	}
        });
        
        sbTRM[2].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iTRM[2] = progress-TRM_SEEKBAR_OFFSET;
        		tvChnValue[2].setText(String.valueOf(iTRM[2])+"%");
        	}
        });
        
        sbTRM[3].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iTRM[3] = progress-TRM_SEEKBAR_OFFSET;
        		tvChnValue[3].setText(String.valueOf(iTRM[3])+"%");
        	}
        }); 
        
        //==========================================
        new AlertDialog.Builder(ConfigChnActivity.this).setTitle("Input Channel TRM").setView(TRMView).setPositiveButton(
        		"OK",new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) { 
            	updateOtherCfgView();
            }  
            /**ӶԻ˳ť,ðťӦ¼*/  
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) {
            	for(int i=0;i<iChnNum;i++){
            		//ԭֵŻأ޸-------------------------
            		iTRM[i] = currentCfg.iTrim[i];            				
                }  
            }  
        }).show(); 
	}	
	
	
	private void inputDR(){

		/**ȡinput_new_profile.xmlļеͼ*/  
        LayoutInflater inflater = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);  
        final View DRView = inflater.inflate(R.layout.input_dr_dlg, null);  
        final Button btnDRLeft[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnDRLeft[0] = (Button) DRView.findViewById(R.id.btnDRLeft1);
        btnDRLeft[1] = (Button) DRView.findViewById(R.id.btnDRLeft2);
        btnDRLeft[2] = (Button) DRView.findViewById(R.id.btnDRLeft3);
        btnDRLeft[3] = (Button) DRView.findViewById(R.id.btnDRLeft4);
        final Button btnDRRight[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnDRRight[0] = (Button) DRView.findViewById(R.id.btnDRRight1);
        btnDRRight[1] = (Button) DRView.findViewById(R.id.btnDRRight2);
        btnDRRight[2] = (Button) DRView.findViewById(R.id.btnDRRight3);
        btnDRRight[3] = (Button) DRView.findViewById(R.id.btnDRRight4);
        
        final SeekBar sbDR[] = new SeekBar[ConstantData.MAX_CHANNEL_NUM];
        sbDR[0]=(SeekBar)DRView.findViewById(R.id.sbDRChn1);
        sbDR[1]=(SeekBar)DRView.findViewById(R.id.sbDRChn2);
        sbDR[2]=(SeekBar)DRView.findViewById(R.id.sbDRChn3);
        sbDR[3]=(SeekBar)DRView.findViewById(R.id.sbDRChn4);
        
        TextView tvChn[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        final TextView tvChnValue[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        
        tvChn[0] = (TextView)DRView.findViewById(R.id.tvDRChn1);
        tvChn[1] = (TextView)DRView.findViewById(R.id.tvDRChn2);
        tvChn[2] = (TextView)DRView.findViewById(R.id.tvDRChn3);
        tvChn[3] = (TextView)DRView.findViewById(R.id.tvDRChn4);
        tvChnValue[0] = (TextView)DRView.findViewById(R.id.tvDRValue1);
        tvChnValue[1] = (TextView)DRView.findViewById(R.id.tvDRValue2);
        tvChnValue[2] = (TextView)DRView.findViewById(R.id.tvDRValue3);
        tvChnValue[3] = (TextView)DRView.findViewById(R.id.tvDRValue4);
        
        for(int i=0; i<ConstantData.MAX_CHANNEL_NUM;i++){
        	sbDR[i].setMax(DR_SEEKBAR_SCALE);
        	sbDR[i].setProgress(iDR[i]+DR_SEEKBAR_OFFSET);
        	tvChnValue[i].setText(String.valueOf(iDR[i])+"%");
        	if(i>=iChnNum){
        		tvChn[i].setVisibility(View.INVISIBLE);
        		tvChnValue[i].setVisibility(View.INVISIBLE);
        		btnDRLeft[i].setVisibility(View.INVISIBLE);
        		btnDRRight[i].setVisibility(View.INVISIBLE);
        		sbDR[i].setVisibility(View.INVISIBLE);        		
        	}
        }
        
        // handler,ť¼(textViewݳ/):
        final Handler handlerDR = new Handler() {
    		public void handleMessage(Message msg) {
    			switch(msg.what) {
    				case DR_LEFT0:
    					if(ConstantData.MINIMUM_DR_VALUE < iDR[0]) iDR[0]--;
    					sbDR[0].setProgress(iDR[0]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[0].setText(String.valueOf(iDR[0])+"%");
    					break;
    				case DR_LEFT1:
    					if(ConstantData.MINIMUM_DR_VALUE < iDR[1]) iDR[1]--;
    					sbDR[1].setProgress(iDR[1]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[1].setText(String.valueOf(iDR[1])+"%");
    					break;
    				case DR_LEFT2:
    					if(ConstantData.MINIMUM_DR_VALUE < iDR[2]) iDR[2]--;
    					sbDR[2].setProgress(iDR[2]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[2].setText(String.valueOf(iDR[2])+"%");
    					break;
    				case DR_LEFT3:
    					if(ConstantData.MINIMUM_DR_VALUE < iDR[3]) iDR[3]--;
    					sbDR[3].setProgress(iDR[3]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[3].setText(String.valueOf(iDR[3])+"%");
    					break;
    				case DR_RIGHT0:
    					if(ConstantData.MAXIMUM_DR_VALUE > iDR[0]) iDR[0]++;
    					sbDR[0].setProgress(iDR[0]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[0].setText(String.valueOf(iDR[0])+"%");
    					break;
    				case DR_RIGHT1:
    					if(ConstantData.MAXIMUM_DR_VALUE > iDR[1]) iDR[1]++;
    					sbDR[1].setProgress(iDR[1]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[1].setText(String.valueOf(iDR[1])+"%");
    					break;
    				case DR_RIGHT2:
    					if(ConstantData.MAXIMUM_DR_VALUE > iDR[2]) iDR[2]++;
    					sbDR[2].setProgress(iDR[2]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[2].setText(String.valueOf(iDR[2])+"%");
    					break;
    				case DR_RIGHT3:
    					if(ConstantData.MAXIMUM_DR_VALUE > iDR[3]) iDR[3]++;
    					sbDR[3].setProgress(iDR[3]+DR_SEEKBAR_OFFSET);
    		        	tvChnValue[3].setText(String.valueOf(iDR[3])+"%");
    					break;
    			}
    			super.handleMessage(msg);
    		}
    	};
        // handler
        
    	// DRĳ¼
    	// Left:
        btnDRLeft[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRLeft[0].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_LEFT0;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnDRLeft[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRLeft[1].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_LEFT1;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnDRLeft[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRLeft[2].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_LEFT2;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnDRLeft[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRLeft[3].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_LEFT3;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // Right:
        btnDRRight[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRRight[0].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_RIGHT0;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnDRRight[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRRight[1].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_RIGHT1;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnDRRight[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRRight[2].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_RIGHT2;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnDRRight[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnDRRight[3].isPressed()){
		                	Message message = new Message();
		                	message.what = DR_RIGHT3;		                	
		    		    	handlerDR.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // DRĳ¼ 
        
        
        btnDRLeft[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_DR_VALUE < iDR[0]) iDR[0]--;
				sbDR[0].setProgress(iDR[0]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[0].setText(String.valueOf(iDR[0])+"%");
			}        	
        });
        
        btnDRLeft[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_DR_VALUE < iDR[1]) iDR[1]--;
				sbDR[1].setProgress(iDR[1]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[1].setText(String.valueOf(iDR[1])+"%");
			}        	
        });
        
        btnDRLeft[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_DR_VALUE < iDR[2]) iDR[2]--;
				sbDR[2].setProgress(iDR[2]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[2].setText(String.valueOf(iDR[2])+"%");
			}        	
        });
        
        btnDRLeft[3].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_DR_VALUE < iDR[3]) iDR[3]--;
				sbDR[3].setProgress(iDR[3]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[3].setText(String.valueOf(iDR[3])+"%");
			}        	
        });
        
        btnDRRight[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_DR_VALUE > iDR[0]) iDR[0]++;
				sbDR[0].setProgress(iDR[0]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[0].setText(String.valueOf(iDR[0])+"%");
			}        	
        });
        
        btnDRRight[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_DR_VALUE > iDR[1]) iDR[1]++;
				sbDR[1].setProgress(iDR[1]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[1].setText(String.valueOf(iDR[1])+"%");
			}        	
        });
        
        btnDRRight[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_DR_VALUE > iDR[2]) iDR[2]++;
				sbDR[2].setProgress(iDR[2]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[2].setText(String.valueOf(iDR[2])+"%");
			}        	
        });
        
        btnDRRight[3].setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_DR_VALUE > iDR[3]) iDR[3]++;
				sbDR[3].setProgress(iDR[3]+DR_SEEKBAR_OFFSET);
	        	tvChnValue[3].setText(String.valueOf(iDR[3])+"%");
			}        	
        });       
        
        sbDR[0].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iDR[0] = progress-DR_SEEKBAR_OFFSET;
        		tvChnValue[0].setText(String.valueOf(iDR[0])+"%");
        	}
        });
        
        sbDR[1].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iDR[1] = progress-DR_SEEKBAR_OFFSET;
        		tvChnValue[1].setText(String.valueOf(iDR[1])+"%");
        	}
        });
        
        sbDR[2].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iDR[2] = progress-DR_SEEKBAR_OFFSET;
        		tvChnValue[2].setText(String.valueOf(iDR[2])+"%");
        	}
        });
        
        sbDR[3].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iDR[3] = progress-DR_SEEKBAR_OFFSET;
        		tvChnValue[3].setText(String.valueOf(iDR[3])+"%");
        	}
        }); 
        
        
        //==========================================         
        new AlertDialog.Builder(ConfigChnActivity.this).setTitle("Input Channel DR").setView(DRView).setPositiveButton(
        		"OK",new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) { 
            	updateOtherCfgView();
            }  
            //ӶԻ˳ť,ðťӦ¼ 
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) {
            	for(int i=0;i<iChnNum;i++){
            		//ԭֵŻأ޸-------------------------
            		iDR[i] = currentCfg.iDR[i];            				
                }  
            }  
        }).show(); 
        
         /*
        //======
        final Builder dlg = new AlertDialog.Builder(ConfigChnActivity.this).setTitle("Input Channel DR").setView(DRView);
        Button btnDROK =(Button)DRView.findViewById(R.id.btnCfgOK);
        btnDROK.setOnClickListener(new Button.OnClickListener(){
                    public void onClick(View v){
                    	updateOtherCfgView();
                   }
                });
        Button btnDRCancel =(Button)DRView.findViewById(R.id.btnCfgCancel);
        btnDRCancel.setOnClickListener(new Button.OnClickListener(){
                    public void onClick(View v){
                    	for(int i=0;i<iChnNum;i++){
                    		//ԭֵŻأ޸-------------------------
                    		iDR[i] = currentCfg.iDR[i];            				
                        } 
                   }
                });
        dlg.create();
        dlg.show();
        //========
        
        // =====
        */
	}
	
	private void inputEPA(){
		/**ȡinput_new_profile.xmlļеͼ*/  
        LayoutInflater inflater = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);  
        final View EPAView = inflater.inflate(R.layout.input_epa_dlg, null);  
        final Button btnEPANLeft[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnEPANLeft[0] = (Button) EPAView.findViewById(R.id.btnEPANLeft1);
        btnEPANLeft[1] = (Button) EPAView.findViewById(R.id.btnEPANLeft2);
        btnEPANLeft[2] = (Button) EPAView.findViewById(R.id.btnEPANLeft3);
        btnEPANLeft[3] = (Button) EPAView.findViewById(R.id.btnEPANLeft4);
        final Button btnEPANRight[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnEPANRight[0] = (Button) EPAView.findViewById(R.id.btnEPANRight1);
        btnEPANRight[1] = (Button) EPAView.findViewById(R.id.btnEPANRight2);
        btnEPANRight[2] = (Button) EPAView.findViewById(R.id.btnEPANRight3);
        btnEPANRight[3] = (Button) EPAView.findViewById(R.id.btnEPANRight4);
        
        final SeekBar sbEPAN[] = new SeekBar[ConstantData.MAX_CHANNEL_NUM];
        sbEPAN[0]=(SeekBar)EPAView.findViewById(R.id.sbEPANChn1);
        sbEPAN[1]=(SeekBar)EPAView.findViewById(R.id.sbEPANChn2);
        sbEPAN[2]=(SeekBar)EPAView.findViewById(R.id.sbEPANChn3);
        sbEPAN[3]=(SeekBar)EPAView.findViewById(R.id.sbEPANChn4);
        
        TextView tvEPAChn[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        tvEPAChn[0] = (TextView)EPAView.findViewById(R.id.tvEPAChn1);
        tvEPAChn[1] = (TextView)EPAView.findViewById(R.id.tvEPAChn2);
        tvEPAChn[2] = (TextView)EPAView.findViewById(R.id.tvEPAChn3);
        tvEPAChn[3] = (TextView)EPAView.findViewById(R.id.tvEPAChn4);
        
        final TextView tvEPANValue[] = new TextView[ConstantData.MAX_CHANNEL_NUM];        
        
        tvEPANValue[0] = (TextView)EPAView.findViewById(R.id.tvEPANValue1);
        tvEPANValue[1] = (TextView)EPAView.findViewById(R.id.tvEPANValue2);
        tvEPANValue[2] = (TextView)EPAView.findViewById(R.id.tvEPANValue3);
        tvEPANValue[3] = (TextView)EPAView.findViewById(R.id.tvEPANValue4);
        
        for(int i=0; i<ConstantData.MAX_CHANNEL_NUM;i++){
        	sbEPAN[i].setMax(EPA_N_SEEKBAR_SCALE);
        	sbEPAN[i].setProgress(iEPANegative[i]+EPA_N_SEEKBAR_OFFSET);
        	tvEPANValue[i].setText(String.valueOf(iEPANegative[i])+"%");
        	if(i>=iChnNum){
        		tvEPAChn[i].setVisibility(View.INVISIBLE);
        		tvEPANValue[i].setVisibility(View.INVISIBLE);
        		btnEPANLeft[i].setVisibility(View.INVISIBLE);
        		btnEPANRight[i].setVisibility(View.INVISIBLE);
        		sbEPAN[i].setVisibility(View.INVISIBLE);        		
        	}
        }        

        // handler,ť¼(textViewݳ/):
        final Handler handlerEPAN = new Handler() {
    		public void handleMessage(Message msg) {
    			switch(msg.what) {
    				case EPAN_LEFT0:
    					if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[0]) iEPANegative[0]--;
    					sbEPAN[0].setProgress(iEPANegative[0]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[0].setText(String.valueOf(iEPANegative[0])+"%");
    					break;
    				case EPAN_LEFT1:
    					if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[1]) iEPANegative[1]--;
    					sbEPAN[1].setProgress(iEPANegative[1]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[1].setText(String.valueOf(iEPANegative[1])+"%");
    					break;
    				case EPAN_LEFT2:
    					if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[2]) iEPANegative[2]--;
    					sbEPAN[2].setProgress(iEPANegative[2]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[2].setText(String.valueOf(iEPANegative[2])+"%");
    					break;
    				case EPAN_LEFT3:
    					if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[3]) iEPANegative[3]--;
    					sbEPAN[3].setProgress(iEPANegative[3]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[3].setText(String.valueOf(iEPANegative[3])+"%");
    					break;
    				case EPAN_RIGHT0:
    					if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[0]) iEPANegative[0]++;
    					sbEPAN[0].setProgress(iEPANegative[0]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[0].setText(String.valueOf(iEPANegative[0])+"%");
    					break;
    				case EPAN_RIGHT1:
    					if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[1]) iEPANegative[1]++;
    					sbEPAN[1].setProgress(iEPANegative[1]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[1].setText(String.valueOf(iEPANegative[1])+"%");
    					break;
    				case EPAN_RIGHT2:
    					if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[2]) iEPANegative[2]++;
    					sbEPAN[2].setProgress(iEPANegative[2]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[2].setText(String.valueOf(iEPANegative[2])+"%");
    					break;
    				case EPAN_RIGHT3:
    					if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[3]) iEPANegative[3]++;
    					sbEPAN[3].setProgress(iEPANegative[3]+EPA_N_SEEKBAR_OFFSET);
    		        	tvEPANValue[3].setText(String.valueOf(iEPANegative[3])+"%");
    					break;    				
    			}
    			super.handleMessage(msg);
    		}
    	};
        // handler
        
    	// EPANĳ¼
    	// Left:
        btnEPANLeft[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANLeft[0].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_LEFT0;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPANLeft[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANLeft[1].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_LEFT1;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPANLeft[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANLeft[2].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_LEFT2;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPANLeft[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANLeft[3].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_LEFT3;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // Right:
        btnEPANRight[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANRight[0].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_RIGHT0;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPANRight[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANRight[1].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_RIGHT1;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPANRight[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANRight[2].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_RIGHT2;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPANRight[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPANRight[3].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAN_RIGHT3;		                	
		    		    	handlerEPAN.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        }); 
        // EPANĳ¼ 
        
        btnEPANLeft[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[0]) iEPANegative[0]--;
				sbEPAN[0].setProgress(iEPANegative[0]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[0].setText(String.valueOf(iEPANegative[0])+"%");
			}        	
        });
        
        btnEPANLeft[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[1]) iEPANegative[1]--;
				sbEPAN[1].setProgress(iEPANegative[1]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[1].setText(String.valueOf(iEPANegative[1])+"%");
			}        	
        });
        
        btnEPANLeft[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[2]) iEPANegative[2]--;
				sbEPAN[2].setProgress(iEPANegative[2]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[2].setText(String.valueOf(iEPANegative[2])+"%");
			}        	
        });
        
        btnEPANLeft[3].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(-ConstantData.MAXIMUM_EPA_VALUE < iEPANegative[3]) iEPANegative[3]--;
				sbEPAN[3].setProgress(iEPANegative[3]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[3].setText(String.valueOf(iEPANegative[3])+"%");
			}        	
        });
        
        btnEPANRight[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[0]) iEPANegative[0]++;
				sbEPAN[0].setProgress(iEPANegative[0]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[0].setText(String.valueOf(iEPANegative[0])+"%");
			}        	
        });
        
        btnEPANRight[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[1]) iEPANegative[1]++;
				sbEPAN[1].setProgress(iEPANegative[1]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[1].setText(String.valueOf(iEPANegative[1])+"%");
			}        	
        });
        
        btnEPANRight[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[2]) iEPANegative[2]++;
				sbEPAN[2].setProgress(iEPANegative[2]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[2].setText(String.valueOf(iEPANegative[2])+"%");
			}        	
        });
        
        btnEPANRight[3].setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE > iEPANegative[3]) iEPANegative[3]++;
				sbEPAN[3].setProgress(iEPANegative[3]+EPA_N_SEEKBAR_OFFSET);
	        	tvEPANValue[3].setText(String.valueOf(iEPANegative[3])+"%");
			}        	
        });       
        
        sbEPAN[0].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPANegative[0] = progress-EPA_N_SEEKBAR_OFFSET;
        		tvEPANValue[0].setText(String.valueOf(iEPANegative[0])+"%");
        	}
        });
        
        sbEPAN[1].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPANegative[1] = progress-EPA_N_SEEKBAR_OFFSET;
        		tvEPANValue[1].setText(String.valueOf(iEPANegative[1])+"%");
        	}
        });
        
        sbEPAN[2].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPANegative[2] = progress-EPA_N_SEEKBAR_OFFSET;
        		tvEPANValue[2].setText(String.valueOf(iEPANegative[2])+"%");
        	}
        });
        
        sbEPAN[3].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPANegative[3] = progress-EPA_N_SEEKBAR_OFFSET;
        		tvEPANValue[3].setText(String.valueOf(iEPANegative[3])+"%");
        	}
        }); 
        
        //=======================POSITIVE IS COMING... ========================
 
        final Button btnEPAPLeft[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnEPAPLeft[0] = (Button) EPAView.findViewById(R.id.btnEPAPLeft1);
        btnEPAPLeft[1] = (Button) EPAView.findViewById(R.id.btnEPAPLeft2);
        btnEPAPLeft[2] = (Button) EPAView.findViewById(R.id.btnEPAPLeft3);
        btnEPAPLeft[3] = (Button) EPAView.findViewById(R.id.btnEPAPLeft4);
        final Button btnEPAPRight[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnEPAPRight[0] = (Button) EPAView.findViewById(R.id.btnEPAPRight1);
        btnEPAPRight[1] = (Button) EPAView.findViewById(R.id.btnEPAPRight2);
        btnEPAPRight[2] = (Button) EPAView.findViewById(R.id.btnEPAPRight3);
        btnEPAPRight[3] = (Button) EPAView.findViewById(R.id.btnEPAPRight4);
        
        final SeekBar sbEPAP[] = new SeekBar[ConstantData.MAX_CHANNEL_NUM];
        sbEPAP[0]=(SeekBar)EPAView.findViewById(R.id.sbEPAPChn1);
        sbEPAP[1]=(SeekBar)EPAView.findViewById(R.id.sbEPAPChn2);
        sbEPAP[2]=(SeekBar)EPAView.findViewById(R.id.sbEPAPChn3);
        sbEPAP[3]=(SeekBar)EPAView.findViewById(R.id.sbEPAPChn4);
        
        final TextView tvEPAPValue[] = new TextView[ConstantData.MAX_CHANNEL_NUM];        
        
        tvEPAPValue[0] = (TextView)EPAView.findViewById(R.id.tvEPAPValue1);
        tvEPAPValue[1] = (TextView)EPAView.findViewById(R.id.tvEPAPValue2);
        tvEPAPValue[2] = (TextView)EPAView.findViewById(R.id.tvEPAPValue3);
        tvEPAPValue[3] = (TextView)EPAView.findViewById(R.id.tvEPAPValue4);
        
        for(int i=0; i<ConstantData.MAX_CHANNEL_NUM;i++){
        	sbEPAP[i].setMax(EPA_P_SEEKBAR_SCALE);
        	sbEPAP[i].setProgress(iEPAPositive[i]+EPA_P_SEEKBAR_OFFSET);
        	tvEPAPValue[i].setText(String.valueOf(iEPAPositive[i])+"%");
        	if(i>=iChnNum){        		
        		tvEPAPValue[i].setVisibility(View.INVISIBLE);
        		btnEPAPLeft[i].setVisibility(View.INVISIBLE);
        		btnEPAPRight[i].setVisibility(View.INVISIBLE);
        		sbEPAP[i].setVisibility(View.INVISIBLE);        		
        	}
        }
        
     // handler,ť¼(textViewݳ/):
        final Handler handlerEPAP = new Handler() {
    		public void handleMessage(Message msg) {
    			switch(msg.what) {
    				case EPAP_LEFT0:
    					if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[0]) iEPAPositive[0]--;
    					sbEPAP[0].setProgress(iEPAPositive[0]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[0].setText(String.valueOf(iEPAPositive[0])+"%");
    					break;
    				case EPAP_LEFT1:
    					if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[1]) iEPAPositive[1]--;
    					sbEPAP[1].setProgress(iEPAPositive[1]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[1].setText(String.valueOf(iEPAPositive[1])+"%");
    					break;
    				case EPAP_LEFT2:
    					if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[2]) iEPAPositive[2]--;
    					sbEPAP[2].setProgress(iEPAPositive[2]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[2].setText(String.valueOf(iEPAPositive[2])+"%");
    					break;
    				case EPAP_LEFT3:
    					if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[3]) iEPAPositive[3]--;
    					sbEPAP[3].setProgress(iEPAPositive[3]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[3].setText(String.valueOf(iEPAPositive[3])+"%");
    					break;
    				case EPAP_RIGHT0:
    					if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[0]) iEPAPositive[0]++;
    					sbEPAP[0].setProgress(iEPAPositive[0]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[0].setText(String.valueOf(iEPAPositive[0])+"%");
    					break;
    				case EPAP_RIGHT1:
    					if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[1]) iEPAPositive[1]++;
    					sbEPAP[1].setProgress(iEPAPositive[1]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[1].setText(String.valueOf(iEPAPositive[1])+"%");
    					break;
    				case EPAP_RIGHT2:
    					if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[2]) iEPAPositive[2]++;
    					sbEPAP[2].setProgress(iEPAPositive[2]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[2].setText(String.valueOf(iEPAPositive[2])+"%");
    					break;
    				case EPAP_RIGHT3:
    					if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[3]) iEPAPositive[3]++;
    					sbEPAP[3].setProgress(iEPAPositive[3]+EPA_P_SEEKBAR_OFFSET);
    		        	tvEPAPValue[3].setText(String.valueOf(iEPAPositive[3])+"%");
    					break;    				
    			}
    			super.handleMessage(msg);
    		}
    	};
        // handler

    	// EPAPĳ¼
    	// Left:
        btnEPAPLeft[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPLeft[0].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_LEFT0;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPAPLeft[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPLeft[1].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_LEFT1;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPAPLeft[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPLeft[2].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_LEFT2;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPAPLeft[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPLeft[3].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_LEFT3;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // Right:
        btnEPAPRight[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPRight[0].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_RIGHT0;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPAPRight[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPRight[1].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_RIGHT1;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPAPRight[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPRight[2].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_RIGHT2;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEPAPRight[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEPAPRight[3].isPressed()){
		                	Message message = new Message();
		                	message.what = EPAP_RIGHT3;		                	
		    		    	handlerEPAP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        }); 
        // EPAPĳ¼ 
        
        btnEPAPLeft[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[0]) iEPAPositive[0]--;
				sbEPAP[0].setProgress(iEPAPositive[0]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[0].setText(String.valueOf(iEPAPositive[0])+"%");
			}        	
        });
        
        btnEPAPLeft[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[1]) iEPAPositive[1]--;
				sbEPAP[1].setProgress(iEPAPositive[1]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[1].setText(String.valueOf(iEPAPositive[1])+"%");
			}        	
        });
        
        btnEPAPLeft[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[2]) iEPAPositive[2]--;
				sbEPAP[2].setProgress(iEPAPositive[2]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[2].setText(String.valueOf(iEPAPositive[2])+"%");
			}        	
        });
        
        btnEPAPLeft[3].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EPA_VALUE < iEPAPositive[3]) iEPAPositive[3]--;
				sbEPAP[3].setProgress(iEPAPositive[3]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[3].setText(String.valueOf(iEPAPositive[3])+"%");
			}        	
        });
        
        btnEPAPRight[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[0]) iEPAPositive[0]++;
				sbEPAP[0].setProgress(iEPAPositive[0]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[0].setText(String.valueOf(iEPAPositive[0])+"%");
			}        	
        });
        
        btnEPAPRight[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[1]) iEPAPositive[1]++;
				sbEPAP[1].setProgress(iEPAPositive[1]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[1].setText(String.valueOf(iEPAPositive[1])+"%");
			}        	
        });
        
        btnEPAPRight[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[2]) iEPAPositive[2]++;
				sbEPAP[2].setProgress(iEPAPositive[2]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[2].setText(String.valueOf(iEPAPositive[2])+"%");
			}        	
        });
        
        btnEPAPRight[3].setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EPA_VALUE > iEPAPositive[3]) iEPAPositive[3]++;
				sbEPAP[3].setProgress(iEPAPositive[3]+EPA_P_SEEKBAR_OFFSET);
	        	tvEPAPValue[3].setText(String.valueOf(iEPAPositive[3])+"%");
			}        	
        });       
        
        sbEPAP[0].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPAPositive[0] = progress-EPA_P_SEEKBAR_OFFSET;
        		tvEPAPValue[0].setText(String.valueOf(iEPAPositive[0])+"%");
        	}
        });
        
        sbEPAP[1].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPAPositive[1] = progress-EPA_P_SEEKBAR_OFFSET;
        		tvEPAPValue[1].setText(String.valueOf(iEPAPositive[1])+"%");
        	}
        });
        
        sbEPAP[2].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPAPositive[2] = progress-EPA_P_SEEKBAR_OFFSET;
        		tvEPAPValue[2].setText(String.valueOf(iEPAPositive[2])+"%");
        	}
        });
        
        sbEPAP[3].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEPAPositive[3] = progress-EPA_P_SEEKBAR_OFFSET;
        		tvEPAPValue[3].setText(String.valueOf(iEPAPositive[3])+"%");
        	}
        }); 
        
        //==========================END OF POSITIVE MASS================         
        new AlertDialog.Builder(ConfigChnActivity.this).setView(EPAView).setPositiveButton(
        		"OK",new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) { 
            	updateOtherCfgView();
            }  
            //ӶԻ˳ť,ðťӦ¼ 
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) {
            	for(int i=0;i<iChnNum;i++){
            		//ԭֵŻأ޸-------------------------
            		iEPANegative[i] = currentCfg.iEPANegative[i];
            		iEPAPositive[i] = currentCfg.iEPAPositive[i];
                }  
            }  
        }).show();
	}
	
	
	private void inputEXP(){

		/**ȡinput_new_profile.xmlļеͼ*/  
        LayoutInflater inflater = (LayoutInflater) getSystemService(LAYOUT_INFLATER_SERVICE);  
        final View EXPView = inflater.inflate(R.layout.input_exp_dlg, null);  
        final Button btnEXPLeft[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnEXPLeft[0] = (Button) EXPView.findViewById(R.id.btnEXPLeft1);
        btnEXPLeft[1] = (Button) EXPView.findViewById(R.id.btnEXPLeft2);
        btnEXPLeft[2] = (Button) EXPView.findViewById(R.id.btnEXPLeft3);
        btnEXPLeft[3] = (Button) EXPView.findViewById(R.id.btnEXPLeft4);
        final Button btnEXPRight[] = new Button[ConstantData.MAX_CHANNEL_NUM];
        btnEXPRight[0] = (Button) EXPView.findViewById(R.id.btnEXPRight1);
        btnEXPRight[1] = (Button) EXPView.findViewById(R.id.btnEXPRight2);
        btnEXPRight[2] = (Button) EXPView.findViewById(R.id.btnEXPRight3);
        btnEXPRight[3] = (Button) EXPView.findViewById(R.id.btnEXPRight4);
        
        final SeekBar sbEXP[] = new SeekBar[ConstantData.MAX_CHANNEL_NUM];
        sbEXP[0]=(SeekBar)EXPView.findViewById(R.id.sbEXPChn1);
        sbEXP[1]=(SeekBar)EXPView.findViewById(R.id.sbEXPChn2);
        sbEXP[2]=(SeekBar)EXPView.findViewById(R.id.sbEXPChn3);
        sbEXP[3]=(SeekBar)EXPView.findViewById(R.id.sbEXPChn4);
        
        TextView tvChn[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        final TextView tvChnValue[] = new TextView[ConstantData.MAX_CHANNEL_NUM];
        
        tvChn[0] = (TextView)EXPView.findViewById(R.id.tvEXPChn1);
        tvChn[1] = (TextView)EXPView.findViewById(R.id.tvEXPChn2);
        tvChn[2] = (TextView)EXPView.findViewById(R.id.tvEXPChn3);
        tvChn[3] = (TextView)EXPView.findViewById(R.id.tvEXPChn4);
        tvChnValue[0] = (TextView)EXPView.findViewById(R.id.tvEXPValue1);
        tvChnValue[1] = (TextView)EXPView.findViewById(R.id.tvEXPValue2);
        tvChnValue[2] = (TextView)EXPView.findViewById(R.id.tvEXPValue3);
        tvChnValue[3] = (TextView)EXPView.findViewById(R.id.tvEXPValue4);
        
        for(int i=0; i<ConstantData.MAX_CHANNEL_NUM;i++){
        	sbEXP[i].setMax(EXP_SEEKBAR_SCALE);
        	sbEXP[i].setProgress(iEXP[i]+EXP_SEEKBAR_OFFSET);
        	tvChnValue[i].setText(String.valueOf(iEXP[i])+"%");
        	if(i>=iChnNum){
        		tvChn[i].setVisibility(View.INVISIBLE);
        		tvChnValue[i].setVisibility(View.INVISIBLE);
        		btnEXPLeft[i].setVisibility(View.INVISIBLE);
        		btnEXPRight[i].setVisibility(View.INVISIBLE);
        		sbEXP[i].setVisibility(View.INVISIBLE);        		
        	}
        }
        

        // handler,ť¼(textViewݳ/):
        final Handler handlerEXP = new Handler() {
    		public void handleMessage(Message msg) {
    			switch(msg.what) {
    				case EXP_LEFT0:
    					if(ConstantData.MINIMUM_EXP_VALUE < iEXP[0]) iEXP[0]--;
    					sbEXP[0].setProgress(iEXP[0]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[0].setText(String.valueOf(iEXP[0])+"%");
    					break;
    				case EXP_LEFT1:
    					if(ConstantData.MINIMUM_EXP_VALUE < iEXP[1]) iEXP[1]--;
    					sbEXP[1].setProgress(iEXP[1]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[1].setText(String.valueOf(iEXP[1])+"%");
    					break;
    				case EXP_LEFT2:
    					if(ConstantData.MINIMUM_EXP_VALUE < iEXP[2]) iEXP[2]--;
    					sbEXP[2].setProgress(iEXP[2]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[2].setText(String.valueOf(iEXP[2])+"%");
    					break;
    				case EXP_LEFT3:
    					if(ConstantData.MINIMUM_EXP_VALUE < iEXP[3]) iEXP[3]--;
    					sbEXP[3].setProgress(iEXP[3]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[3].setText(String.valueOf(iEXP[3])+"%");
    					break;
    				case EXP_RIGHT0:
    					if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[0]) iEXP[0]++;
    					sbEXP[0].setProgress(iEXP[0]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[0].setText(String.valueOf(iEXP[0])+"%");
    					break;
    				case EXP_RIGHT1:
    					if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[1]) iEXP[1]++;
    					sbEXP[1].setProgress(iEXP[1]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[1].setText(String.valueOf(iEXP[1])+"%");
    					break;
    				case EXP_RIGHT2:
    					if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[2]) iEXP[2]++;
    					sbEXP[2].setProgress(iEXP[2]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[2].setText(String.valueOf(iEXP[2])+"%");
    					break;
    				case EXP_RIGHT3:
    					if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[3]) iEXP[3]++;
    					sbEXP[3].setProgress(iEXP[3]+EXP_SEEKBAR_OFFSET);
    		        	tvChnValue[3].setText(String.valueOf(iEXP[3])+"%");
    					break;
    			}
    			super.handleMessage(msg);
    		}
    	};
        // handler
        
    	// EXPĳ¼
    	// Left:
        btnEXPLeft[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPLeft[0].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_LEFT0;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEXPLeft[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPLeft[1].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_LEFT1;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEXPLeft[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPLeft[2].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_LEFT2;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEXPLeft[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPLeft[3].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_LEFT3;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // Right:
        btnEXPRight[0].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPRight[0].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_RIGHT0;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEXPRight[1].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPRight[1].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_RIGHT1;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEXPRight[2].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPRight[2].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_RIGHT2;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        btnEXPRight[3].setOnLongClickListener(new OnLongClickListener(){
			@Override
			public boolean onLongClick(View v) {
				// ⳤ,ϢȥtextViewʾ1
				final Timer t = new Timer();
		        TimerTask tt = new TimerTask(){
		            @Override
		            public void run(){
		                if(btnEXPRight[3].isPressed()){
		                	Message message = new Message();
		                	message.what = EXP_RIGHT3;		                	
		    		    	handlerEXP.sendMessage(message);	                	
		                }else{
		                	t.cancel();
		            	}
		            }
		        };        
		        t.schedule(tt, 50, 50);			
				return false;
			}        	
        });
        // EXPĳ¼ 
        
        
        btnEXPLeft[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EXP_VALUE < iEXP[0]) iEXP[0]--;
				sbEXP[0].setProgress(iEXP[0]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[0].setText(String.valueOf(iEXP[0])+"%");
			}        	
        });
        
        btnEXPLeft[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EXP_VALUE < iEXP[1]) iEXP[1]--;
				sbEXP[1].setProgress(iEXP[1]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[1].setText(String.valueOf(iEXP[1])+"%");
			}        	
        });
        
        btnEXPLeft[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EXP_VALUE < iEXP[2]) iEXP[2]--;
				sbEXP[2].setProgress(iEXP[2]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[2].setText(String.valueOf(iEXP[2])+"%");
			}        	
        });
        
        btnEXPLeft[3].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MINIMUM_EXP_VALUE < iEXP[3]) iEXP[3]--;
				sbEXP[3].setProgress(iEXP[3]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[3].setText(String.valueOf(iEXP[3])+"%");
			}        	
        });
        
        btnEXPRight[0].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[0]) iEXP[0]++;
				sbEXP[0].setProgress(iEXP[0]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[0].setText(String.valueOf(iEXP[0])+"%");
			}        	
        });
        
        btnEXPRight[1].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[1]) iEXP[1]++;
				sbEXP[1].setProgress(iEXP[1]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[1].setText(String.valueOf(iEXP[1])+"%");
			}        	
        });
        
        btnEXPRight[2].setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[2]) iEXP[2]++;
				sbEXP[2].setProgress(iEXP[2]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[2].setText(String.valueOf(iEXP[2])+"%");
			}        	
        });
        
        btnEXPRight[3].setOnClickListener(new OnClickListener(){

			@Override
			public void onClick(View v) {
				if(ConstantData.MAXIMUM_EXP_VALUE > iEXP[3]) iEXP[3]++;
				sbEXP[3].setProgress(iEXP[3]+EXP_SEEKBAR_OFFSET);
	        	tvChnValue[3].setText(String.valueOf(iEXP[3])+"%");
			}        	
        });       
        
        sbEXP[0].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEXP[0] = progress-EXP_SEEKBAR_OFFSET;
        		tvChnValue[0].setText(String.valueOf(iEXP[0])+"%");
        	}
        });
        
        sbEXP[1].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEXP[1] = progress-EXP_SEEKBAR_OFFSET;
        		tvChnValue[1].setText(String.valueOf(iEXP[1])+"%");
        	}
        });
        
        sbEXP[2].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEXP[2] = progress-EXP_SEEKBAR_OFFSET;
        		tvChnValue[2].setText(String.valueOf(iEXP[2])+"%");
        	}
        });
        
        sbEXP[3].setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
        	@Override
        	public void onStopTrackingTouch(SeekBar arg0) { }
        	@Override
        	public void onStartTrackingTouch(SeekBar arg0) { }

        	@Override
        	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        		iEXP[3] = progress-EXP_SEEKBAR_OFFSET;
        		tvChnValue[3].setText(String.valueOf(iEXP[3])+"%");
        	}
        }); 
        
        
        //==========================================         
        new AlertDialog.Builder(ConfigChnActivity.this).setTitle("Input Channel EXP").setView(EXPView).setPositiveButton(
        		"OK",new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) { 
            	updateOtherCfgView();
            }  
            //ӶԻ˳ť,ðťӦ¼ 
        }).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {  
              
            @Override  
            public void onClick(DialogInterface arg0, int arg1) {
            	for(int i=0;i<iChnNum;i++){
            		//ԭֵŻأ޸-------------------------
            		iEXP[i] = currentCfg.iEXPControl[i];            				
                }  
            }  
        }).show(); 
       
	}
	
	
    private void updateOtherCfgView(){
    	String tmpStr = "REV  ";
        for(int i=0;i<iChnNum;i++){
        	tmpStr += "Chn"+String.valueOf(i);
        	if(true == bChnRev[i]){
        		tmpStr += ": ON ";
        	}else{
        		tmpStr += ": OFF ";
        	}
        }
        btnChnRev.setText(tmpStr);
        
        tmpStr = "TRM  ";
        for(int i=0;i<iChnNum;i++){
        	tmpStr += "Chn"+String.valueOf(i)+": "+String.valueOf(iTRM[i])+"%";
        	if(i != (iChnNum-1)){
        		tmpStr += ", ";
        	}
        }
        btnTRM.setText(tmpStr);
        
        tmpStr = "EPA  ";
        for(int i=0;i<iChnNum;i++){
        	tmpStr += "Chn"+String.valueOf(i)+
        			  ": "+
        			  String.valueOf(iEPANegative[i])+
        			  "%-"+
        			  String.valueOf(iEPAPositive[i])+
        			  "%";
        	if(i != (iChnNum-1)){
        		tmpStr += ", ";
        	}
        }
        btnEPA.setText(tmpStr);
        
        tmpStr = "DR  ";
        for(int i=0;i<iChnNum;i++){
        	tmpStr += "Chn"+String.valueOf(i)+": "+String.valueOf(iDR[i])+"%";
        	if(i != (iChnNum-1)){
        		tmpStr += ", ";
        	}
        }
        btnDR.setText(tmpStr);
        
        tmpStr = "EXP  ";
        for(int i=0;i<iChnNum;i++){
        	tmpStr += "Chn"+String.valueOf(i)+": "+String.valueOf(iEXP[i])+"%";
        	if(i != (iChnNum-1)){
        		tmpStr += ", ";
        	}
        }
        btnEXP.setText(tmpStr);
    }
	
	private ProfileList currentCfg = new ProfileList();
	ConnectWifiApplication app;
	
	protected static final int TRM_SEEKBAR_SCALE = (ConstantData.MAXIMUM_TRIM_VALUE - ConstantData.MINIMUM_TRIM_VALUE);
	protected static final int TRM_SEEKBAR_OFFSET = (ConstantData.MAXIMUM_TRIM_VALUE - ConstantData.MINIMUM_TRIM_VALUE)/2;
	protected static final int DR_SEEKBAR_SCALE = (ConstantData.MAXIMUM_DR_VALUE - ConstantData.MINIMUM_DR_VALUE);
	protected static final int DR_SEEKBAR_OFFSET = -ConstantData.MINIMUM_DR_VALUE;
	protected static final int EPA_N_SEEKBAR_SCALE = 150;
	protected static final int EPA_N_SEEKBAR_OFFSET = 150;
	protected static final int EPA_P_SEEKBAR_SCALE = 150;
	protected static final int EPA_P_SEEKBAR_OFFSET = 0;
	protected static final int EXP_SEEKBAR_SCALE = ConstantData.MAXIMUM_EXP_VALUE - ConstantData.MINIMUM_EXP_VALUE;
	protected static final int EXP_SEEKBAR_OFFSET = (ConstantData.MAXIMUM_EXP_VALUE - ConstantData.MINIMUM_EXP_VALUE)/2;
	
	// ڶmessageϢ,handlereӦ 
	protected static final int TRM_LEFT0 = 1000;
	protected static final int TRM_LEFT1 = 1001;
	protected static final int TRM_LEFT2 = 1002;
	protected static final int TRM_LEFT3 = 1003;
	
	protected static final int TRM_RIGHT0 = 1004;
	protected static final int TRM_RIGHT1 = 1005;
	protected static final int TRM_RIGHT2 = 1006;
	protected static final int TRM_RIGHT3 = 1007;

	protected static final int DR_LEFT0 = 1010;
	protected static final int DR_LEFT1 = 1011;
	protected static final int DR_LEFT2 = 1012;
	protected static final int DR_LEFT3 = 1013;
	protected static final int DR_RIGHT0 = 1014;
	protected static final int DR_RIGHT1 = 1015;
	protected static final int DR_RIGHT2 = 1016;
	protected static final int DR_RIGHT3 = 1017;
	
	protected static final int EPAN_LEFT0 = 1010;
	protected static final int EPAN_LEFT1 = 1011;
	protected static final int EPAN_LEFT2 = 1012;
	protected static final int EPAN_LEFT3 = 1013;
	protected static final int EPAN_RIGHT0 = 1014;
	protected static final int EPAN_RIGHT1 = 1015;
	protected static final int EPAN_RIGHT2 = 1016;
	protected static final int EPAN_RIGHT3 = 1017;
	protected static final int EPAP_LEFT0 = 1010;
	protected static final int EPAP_LEFT1 = 1011;
	protected static final int EPAP_LEFT2 = 1012;
	protected static final int EPAP_LEFT3 = 1013;
	protected static final int EPAP_RIGHT0 = 1014;
	protected static final int EPAP_RIGHT1 = 1015;
	protected static final int EPAP_RIGHT2 = 1016;
	protected static final int EPAP_RIGHT3 = 1017;
	
	protected static final int EXP_LEFT0 = 1010;
	protected static final int EXP_LEFT1 = 1011;
	protected static final int EXP_LEFT2 = 1012;
	protected static final int EXP_LEFT3 = 1013;
	protected static final int EXP_RIGHT0 = 1014;
	protected static final int EXP_RIGHT1 = 1015;
	protected static final int EXP_RIGHT2 = 1016;
	protected static final int EXP_RIGHT3 = 1017;
	
	private Button btnBack,btnSaveNBack,btnDiscard;
	private Button btnTRM,btnDR,btnEPA,btnEXP,btnChnRev;
	private Button btnChnNumLeft,btnChnNumRight;
	private TextView tvChnNum;
	
	private static int iChnNum = ConstantData.INVALID_VALUE;
	private static int iTRM[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static int iDR[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static int iEPAPositive[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static int iEPANegative[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static int iEXP[] = new int[ConstantData.MAX_CHANNEL_NUM];
	private static boolean bChnRev[] = new boolean[ConstantData.MAX_CHANNEL_NUM];
	
	private String fromActivity;
		
}
